# Requires
require 'rubygems'
require 'erubis'

# Utility functions for the module
module PackerFiles

  # Name of the gem of this module. This is useful elsewhere, but primarily
  # to avoid multiple definitions of gem name everywhere.
  @@gem = 'PackerFiles'

  # Accessor for the Gem name
  def self.GemName
    @@gem
  end

  # Accessor for Gem Spec
  def self.GemSpec
    Gem::Specification.find_by_name(self.GemName)
  end

  # Given a Path, return it's absolute path within the context of the Gem
  def self.DirPath(file_name)
     self.GemSpec.matches_for_glob(file_name)
  end

  # Evaluate a given ERB file in a given OS folder with the object
  # hash. The hash contains object bindings in the form of {var, obj}
  # where {var} is present in the erb file.
  def self.evaluate_erb(filename, hash)
     return Erubis::Eruby.new(File.read(filename)).evaluate(hash)
  end

  # Top level function that is called by the DSL to generate all the
  # required PackerFiles
  def self.Generate(os_name, version = nil, &block)
     require 'Finder'
     finder = Finder.new
     obj    = finder.class_name(os_name, version).new(&block)
     obj.Generate
  end


end
