# Requires
require 'thor'
require_relative 'OS'

# The ROOT of all the CLI commands. Other Sub commands are
# declared as they go.
module PackerFiles
  module CLI
     class Root < Thor

        # define sub-command for OS
        desc "os SUBCOMMAND ...ARGS", "Commands on Supported OS"
        subcommand "os", OS

        # define the default task as generate
        default_task :generate

        # Default command that generates various artificats for Packer to
        # work correctly.
        desc "generate", "Generate Artificats for packer to work correctly"
        option :defaults, :desc    => 'Use Defaults for missing values', 
                          :type    => :boolean, 
                          :default => false
        option :file,     :desc => 'OS Spec. File', :default => 'PackerFile',
                          :type => :string 
        def generate
	   if !File.exist?options[:file]
	      puts "File not found #{options[:file]}"
	      exit(1)
           end
	   begin
              load(options[:file])
           rescue PackerFiles::Core::Error => e
              puts "Error: #{e.message}"
              exit(1)
           end
        end

     end
  end
end
