# Requires


# Exceptions generated by the PackerFile generator.
module PackerFiles

   module Core

      # The top level class for all exceptions shown by this gem.
      class Error   < Exception
	 attr_accessor :message
      end
    
      # The Nil exception is generated when a particular class member is nil. 
      class NilException < Error

	 # Constructor. 
	 def initialize(obj, member_name)
	    @super
	    class_name   = obj.class.name.gsub(/.*::/, '')
	    self.message = "#{class_name}.#{member_name} is not set"
	 end
      end

      # The EmptyArray Exception is generated when a particular class member array
      # is empty.
      class EmptyArrayException < Error

	 # Constructor. 
	 def initialize(obj, member_name)
	    @super
	    class_name   = obj.class.name.gsub(/.*::/, '')
	    self.message = "#{class_name}.#{member_name} is empty" 
	 end
      end

      # The Size Exception is generated when child object sizes are greater than
      # that of Parent objects.
      class SizeException < Error

	 # Constructor. 
	 def initialize(parent_obj, child_obj)
	    @super
	    parent  = parent_obj.class.name.gsub(/.*::/, '')
	    child   = child_obj.class.name.gsub(/.*::/, '')
	    self.message = "Sum of #{child} sizes are greater than #{parent} size"
	 end
      end

     # The URL Exception is generated if a URL cannot be opened and it's contents
     # cannot be read.
     class URLException < Error

	# Constructor
	def initialize(url, inner_obj)
	   @super
	   self.message = "URL #{url} could not be opened! HTTP Error: #{inner_obj.to_s}"
	end

     end

   end  # Core

end # PackerFiles
 
