
# Requires
require_relative 'Base'
require_relative 'Exceptions'

module PackerFiles
  module Core

     # Define the Keyboard class that can handle Keyboards specified in a Packerfile.
     # Just the barebones attributes that are required for this class are specified
     # here. The conversion of these attributes into a OS build specific file is 
     # done by derived classes in the OS specific directories.
     class Keyboard < Base

        # Specify attributes
        attr_accessor :layout  
        attr_accessor :variant  

        # Documentation for this class 
        def self.doc_file
	   PackerFiles.DirPath('Core/example/Keyboard.txt').first
        end

        # Constructor to just specify accessor varibales
        def initialize
	   yield self if block_given?
        end

        # Normalize the various values into something useful. The 
        # default implementation checks only errors
        def normalize
         raise NilException.new(self, 'layout') if @layout.nil?
        end

    end

  end #Core
end # PackerFiles
