
# Requires
require 'Utils/Size'
require_relative 'Base'
require_relative 'Exceptions'

module PackerFiles
   module Core 

     # Abstraction for Logical Volume
     class LogicalVolume < Base

	# Include MiB as a method inside Disk
	include Utils::Size

	# Specify attributes
	attr_accessor :size
	attr_accessor :mount_point
	attr_accessor :file_system 
	attr_accessor :name
	attr_accessor :vg_name

	# Constructor to just specify accessor varibales
	def initialize
	  @size         = 0
	  yield self if block_given?
	end

	# Normalize the values
	def normalize
	  raise NilException.new(self, 'name')    if @name.nil?
	  raise NilException.new(self, 'vg_name') if @vg_name.nil?
	  raise 'size cannot be zero'             if @size == 0
	  @size = MiB(@size) 
	end

     end # LogicalVolume

   end # Core
end # PackerFiles

