
# Requires
require_relative 'Base'
require_relative 'Exceptions'

module PackerFiles

   module Core

      # Define the Partition class that can handle Partition specified in a Packerfile.
      # Just the barebones attributes that are required for this class are specified
      # here. The conversion of these attributes into a OS build specific file is 
      # done by derived classes in the OS specific directories.
      class Partition < Base

	# Specify attributes
	attr_accessor :boot
	attr_accessor :label 
	attr_accessor :size  
	attr_accessor :mount_point
	attr_accessor :file_system  
	attr_accessor :name  

	# Constructor to just specify accessor varibales
	def initialize
	  @boot         = false
	  @size         = 0
	  yield self if block_given?
	end

	# Normalize the values
	def normalize
	  raise NilException.new(self, 'name')  if @name.nil?
	  raise 'size cannot be zero' if @size == 0 
	end

      end # Partition

   end # Core

end # PackerFiles
