
# Requires
require_relative 'Base'
require_relative 'LogicalVolume'

module PackerFiles

   module Core

      # Volume Group abstracts out LVM.
      class VolumeGroup < Base

	# Specify attributes
	attr_accessor :name  
	attr_accessor :disk_names
	attr_accessor :lvs

	# Constructor to just specify accessor varibales
	def initialize
	  @disk_names = []
	  @lvs        = []
	  yield self if block_given?
	end

       # Adds a Logical volume on this disk by doing an instance-eval
	def LogicalVolume(&block)
	   if block_given?
	     lv = LogicalVolume.new
	     lv.instance_eval &block
	     lv.name = 'lv' + @lvs.size.to_s if (lv.name.nil?)
	     @lvs.push(lv)
	   end
	end

	# Normalize the various values into something useful
	def normalize
	   raise 'name is nil'         if @name.nil?
	   raise 'Disk names is empty' if @disk_names.empty?
	   raise 'LVs is empty'        if @lvs.empty?
	   @lvs.each {|lv| 
	      lv.vg_name= @name
	      lv.normalize
	   }
	end

      end

   end  # Core

end # PackerFiles
