# Disk and Partition related
bootloader --location=mbr
zerombr
clearpart --all --initlabel

# Case 1: When just a disk is given, always use the regular atomic
# recipe, unless indicated otherwise.
<% if @obj.is_raw? -%>
autopart
<% end -%>

# Case 2: A disk with multiple partitions
<% if @obj.only_partitions? -%>
  <% @obj.partitions.each do |part| -%>
      <% if part.file_system == 'linux-swap' -%>
         partition swap --recommended --size=<%= part.size -%> --grow
      <% else -%>
         partition <%= part.mount_point -%> --size=<%= part.size -%> --fstype=<%= part.file_system %>
      <% end -%>
  <% end -%>
<% end -%>

# Case 3: A disk with Logical Volumes
<% if @obj.only_vg? -%>
   partition pv.01 --size=<%= @obj.size -%> --grow
   volgroup <%= @obj.vg.name -%> pv.01
   <% @obj.vg.lvs.each do |lv| -%>
       <% if lv.file_system == 'linux-swap' -%>
         logvol swap --recommended --size=<%= lv.size -%> --grow --name=<%= lv.name -%> --vgname=<%= lv.vg_name %>
      <% else -%>
         logvol <%= lv.mount_point -%> --size=<%= lv.size -%> --fstype=<%= lv.file_system -%> --name=<%= lv.name -%> --vgname=<%= lv.vg_name %>
      <% end -%>
   <% end -%> 
<% end -%>

