# Requires
require 'Core/Base'
require 'Core/Exceptions'

# Apt Setup handles all apt-related questions during the initial
# phase of OS installation.
module PackerFiles
 module Debian
   class Apt < Core::Base

     # Accessors
     attr_accessor :tasks
     attr_accessor :non_free
     attr_accessor :contrib
     attr_accessor :upgrades
     attr_accessor :kernel

     # Documentation for this class
     def self.doc_file
        PackerFiles.DirPath('Debian/example/Apt.txt').first
     end

     # Constructor
     def initialize
	@tasks    = []
	@non_free = false
	@contrib  = false
	@upgrades = 'none'
        @kernel   = 'linux-server'
	yield self if block_given?
     end

     # Normalize
     def normalize
       raise Core::NilException.new(self, 'tasks') if @tasks.nil?
       raise Core::NilException.new(self, 'kernel') if @kernel.nil?
       raise Core::EmptyArrayException.new(self, 'tasks') if @tasks.empty?
     end

   end
 end
end
