# Case 1: When just a disk is given, always use the regular atomic
# recipe, unless indicated otherwise.
<% if @obj.is_raw? -%>
<% recipe = 'atomic' if recipe.nil? -%>
 d-i partman-auto/choose_recipe select <%= recipe %>
 d-i partman-auto/method string regular
 d-i partman-partitioning/confirm_write_new_label boolean true
 d-i partman/choose_partition select finish
 d-i partman/confirm boolean true
 d-i partman/confirm_nooverwrite boolean true
<% end -%>

# Case 2: A disk with multiple partitions
<% if @obj.only_partitions? -%>
  d-i partman-auto/method string regular
  d-i partman-partitioning/confirm_write_new_label boolean true
  d-i partman/choose_partition select finish
  d-i partman/confirm boolean true
  d-i partman/confirm_nooverwrite boolean true
  d-i partman-auto/expert_recipe string  \
  boot-root ::  \
  <% @obj.partitions.each do |part| -%>
      <%= (part.size/2) -%> <%= (part.size*3/4) -%> <%= part.size -%> <%= part.file_system -%> \
      <% if part.boot -%>
        $primary{ } $bootable{ } \
      <% end -%>
      <% if part.file_system == 'linux-swap' -%>
        method { swap } format { } \
      <% else -%>
        method { format } format { } \
      <% end  -%>
      <% if !part.file_system.nil? && part.file_system != 'linux-swap' -%>
       use_filesystem{ } filesystem{ <%= part.file_system -%> } \
      <% end -%>
      <% if !part.mount_point.nil? && part.file_system != 'linux-swap' -%>
       mountpoint{ <%= part.mount_point -%> }  \
      <% end -%>
      . \
  <% end -%>
<% end -%>

# Case 3: A disk with Logical Volumes
<% if @obj.only_vg? -%>
  d-i partman-auto/method string lvm
  d-i partman-auto-lvm/guided_size string max
  d-i partman/choose_partition select finish
  d-i partman/confirm_nooverwrite boolean true
  d-i partman-lvm/confirm_nooverwrite boolean true
  d-i partman-auto/expert_recipe string  \
  boot-root-vg ::  \
  <% @obj.vg.lvs.each do |lv| -%>
      <%= (lv.size/2) -%> <%= (lv.size*3/4) -%> <%= lv.size -%> <%= lv.file_system -%> \
      $lvmok{ } in_vg{ <%= lv.vg_name -%> } lv_name{ <%= lv.name -%> } \
      <% if lv.file_system == 'linux-swap' -%>
        method { swap } format { } \
      <% else -%>
        method { format } format { } \
      <% end  -%>
      <% if !lv.file_system.nil? && lv.file_system != 'linux-swap' -%>
       use_filesystem{ } filesystem{ <%= lv.file_system -%> } \
      <% end -%>
      <% if !lv.mount_point.nil? && lv.file_system != 'linux-swap' -%>
       mountpoint{ <%= lv.mount_point -%> }  \
      <% end -%>
      . \
  <% end -%>
<% end -%>


