# Requires
require 'OS/CentOS/Server'
require_relative 'CD'

# OS class that handles details for generating Packer files for RHEL
# Servers.
module PackerFiles
 module RHEL

   class Server < PackerFiles::CentOS::Server

     # Constructor. Yield self for further initialization
     def initialize
	yield self if block_given?
     end 

     # Hook function called before normalizing CD Image
     def cd_image_hook
	self.CDImage.impl = RHEL::CD.new
     end 

     # Name of the preseed file
     def kickstart_file
        rel  = self.CDImage.release
        arch = self.CDImage.arch
        name = "kickstart-rhel-server-#{rel}-#{arch}.cfg"
	File.join(http_dir, name)
     end

  end
 end
end 
