# Requires
require_relative 'Server'
require_relative 'DesktopCD'

# OS class that handles details for generating Packer files for Ubuntu
# Desktop.
module PackerFiles
 module Ubuntu

   class Desktop < Ubuntu::Server

     # Constructor. Yield self for further initialization
     def initialize
        super
     end 

     # Hook function called before normalizing CD Image
     def cd_image_hook
	self.CDImage.impl = Ubuntu::DesktopCD.new
     end 

     # Hook for writing into preseed file.
     def preseed_write_hook(objects)

	# Get Preseed object from the base class.
	preseed = super

	# Generate Ubiquity specific sections.
	preseed.eval_file 'Ubuntu/Templates/ubiquity_erb.rb', {'obj' => self}
     end

     # Name of the preseed file
     def preseed_file
        rel  = self.CDImage.release
        arch = self.CDImage.arch
        name = "preseed-ubuntu-desktop-#{rel}-#{arch}.cfg"
	File.join(http_dir, name)
     end

     # Boot Command Override
     def boot_command
        file  = PackerFiles.DirPath('Ubuntu/Templates/boot_command_desktop_erb.rb')
	hash  = { 'obj' => self}
        value = PackerFiles.evaluate_erb(file.first, hash)
	value.split("\n")
     end

  end
 end
end 
