# Requires
require_relative 'Base'

# The External script class is used for executing a series of external scripts
# inside the VM. 
module PackerFiles
   module Provision 
      class ExternalScript < Base 

         # Various accessors
         hash_variable  :execute_command
         hash_variable  :scripts, Array,   :convert_scripts
	 hash_variable  :binary, Integer,  :convert_to_boolean
         hash_variable  :environment_vars, Hash,   :convert_env_vars
   
         # Conversion function for environment variables.
         def convert_env_vars
	    array = []
	    self.environment_vars.each_pair do |var, value|
	       array.push("#{var}=#{value.to_s}")
	    end
	    array
         end

         # Conversion function for boolean
         def convert_to_boolean
	    (self.binary > 0) ? true : false
	 end

	 # Conversion function for scripts
	 def convert_scripts
	    self.scripts.map {|script| File.absolute_path(script)}
	 end
 
         # Constructor yields self
         def initialize(&block)
	    yield self if block_given?
	    @type = 'shell'
         end 

     end
  end
end
