# Requires
require_relative 'Base'

# The Inline script class is used for executing a series of script commands
# inside the VM. 
module PackerFiles
   module Provision 
      class InlineScript < Base 

         # Various accessors
         hash_variable  :execute_command
         hash_variable  :environment_vars, Hash,   :convert_env_vars
         hash_variable  :inline, String, :convert_inline
   
         # Conversion function for environment variables.
         def convert_env_vars
	    array = []
	    self.environment_vars.each_pair do |var, value|
	       array.push("#{var}=#{value.to_s}")
	    end
	    array
         end
 
         # Conversion function for inline commands
         def convert_inline
            self.inline.split("\n").map {|line| line.strip}
         end
 
         # Constructor yields self
         def initialize(&block)
	    yield self if block_given?
	    @type = 'shell'
         end 

     end
  end
end
