# Requires
require 'Utils/HashSerializer'
require 'json'

module PackerFiles
   module Utils

      # Generates the top level JSON file for Packer to operate upon.
      class Generator < HashSerializer

	# List of Hash Serializers
	hash_variable :variables,    Hash
	hash_variable :builders,     Array 
	hash_variable :provisioners, Array
    
	# Constructor
	def initialize
	   self.builders     = Array.new
	   self.variables    = Hash.new
	   self.provisioners = Array.new
	end 

	# Create the JSON file in the given directory
	def create_json(filename)
	   hash    = self.to_hash
	   content = JSON.pretty_generate(hash) + "\n"
	   File.write(filename, content)
	end

      end # Generator

   end # Utils

end # PackerFiles
